#!/bin/sh

   if [ $# -ne 5 ]; then
         echo 1>&2 Usage: $0 userDB pswDB DBName creamDBVersion creationDBScript
         exit -1
    fi

dbVersionMustBe="$4"
#echo dbVersionMustBe=$dbVersionMustBe
echo  The database version requested by cream service is $dbVersionMustBe
creationDBScript="$5"

# Check if database db_name exist
mysqlshow --password="$2" | grep -w "$3" >/dev/null 2>&1

exitCode=$?
#echo The exit status of the last command $exitCode 

# if database doesn't exist then create and populate it
if [ "$exitCode" -ne 0 ]
then
  echo Database $3 does not exist. Now it will be created and populated.
  mysql --password="$2" < "$creationDBScript" 2>&1
  exitCode=$?
 #echo The exit status of the last command $exitCode

  if [  "$exitCode" -ne 0 ]
  then
    echo An error is occurred on the creation of the  database
    exit -1
  fi
fi

dbVersionFromDb=`mysql -e "select version as dbversion from db_info;" --password="$2" -D "$3" 2>&1 | tr -d "\n" | sed "s/dbversion//g"`
exitCode=$?
#echo The exit status of the last command $exitCode

if [ "`echo  $dbVersionFromDb | grep -o ERROR`" == "ERROR" ]
  then echo "Impossible to retrieve the database version from the database. The database version is set to zero."
       dbVersionFromDb=0
fi

echo The database version retrieved from the database is $dbVersionFromDb

if [ "$exitCode" -ne 0 -o X"$dbVersionMustBe" != X"$dbVersionFromDb" ]
  then
     echo "The $3 database version (db version = $dbVersionFromDb) is not compliant with the one requested by cream service (db version = $dbVersionMustBe)"

     echo Now, the updated database will be created and populated.  
     mysql --password="$2" < "$creationDBScript" 2>&1
     exitCode=$?
 #   echo The exit status of the last command $exitCode
     if [  "$exitCode" -ne 0 ]
     then
       echo 1>&2 An error is occurred on the creation of the database
       exit -1
     fi
 #   remove cream_sandbox
     echo "Removing cream_sandbox ..."
     mv /opt/glite/var/cream_sandbox /opt/glite/var/cream_sandbox_old
     rm -rf /opt/glite/var/cream_sandbox_old &
  else
     if [ $3 == "creamdb" ]
        then
           result=`mysql --password="$2" -N -B -D creamdb -u root -e "SHOW INDEX FROM extra_attribute;"`
           exitCode=$?

           len=${#result}

           #echo The exit status of the last command $exitCode
           if [ "$exitCode" -eq 0 -a "$len" -eq 0  ]
              then
                  echo "creating index for extra_attribute table"
                  mysql --password="$2" -D creamdb -u root -e 'ALTER TABLE extra_attribute ADD CONSTRAINT fk_extra_attribute_jobId_job_id FOREIGN KEY (jobId) REFERENCES job (id) ON UPDATE NO ACTION ON DELETE NO ACTION; CREATE INDEX commandGroupId_Idx ON JOB_MANAGEMENT (commandGroupId);'
           fi
     fi

     echo "The $3 database is synchronized with the one requested by cream service"     
fi


