
/************ Use Delegation DB ***************/

use delegationdb;

/************ Drop: Tables ***************/
DROP TABLE IF EXISTS db_info, t_credential_cache, t_credential, t_credential_vers;

/******************** Add Tables ************************/

CREATE TABLE db_info
(
    version       VARCHAR(5) NOT NULL,
    creationTime  TIMESTAMP  NOT NULL
) ENGINE=InnoDB;

CREATE TABLE t_credential_cache (
   dlg_id	VARCHAR(100),
   dn		VARCHAR(255),
   cert_request	TEXT NOT NULL,
   priv_key	TEXT NOT NULL,
   voms_attrs	TEXT,
   PRIMARY KEY (dlg_id, dn)
) ENGINE=InnoDB;

CREATE TABLE t_credential (
   dlg_id	VARCHAR(100),
   dn		VARCHAR(255),
   proxy	TEXT NOT NULL,
   voms_attrs	TEXT,
   termination_time DATETIME,
   PRIMARY KEY (dlg_id, dn)
) ENGINE=InnoDB;

CREATE TABLE t_credential_vers (
   major	INT,
   minor	INT,
   patch	INT
) ENGINE=InnoDB;

commit;

/******************** Insert row in t_credential_vers table ************************/

insert into t_credential_vers(major, minor, patch) values ('1','2','0');

/************ Insert row in db_info ************************************************/    
insert into db_info (version, creationTime) values ('2.1', now());

commit;
